diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
index 7eac3b146..31bce15cd 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockSlab.java
@@ -8,20 +8,21 @@ import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumBlockSoundEffectType;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T> {
-    public ItemBlockSlab(@NotNull Block<T> block)
-    {
+    public ItemBlockSlab(@NotNull Block<T> block) {
         super(block);
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         int id = world.getBlockId(blockPos);
         int meta = world.getBlockData(blockPos) & 0b11;
         int otherMeta = world.getBlockData(blockPos) & ~0b11;
@@ -29,20 +30,20 @@ public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T> {
             id = 0;
             meta = 0;
         }
-        if (selfStack.stackSize <= 0 || blockPos.y == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
+        if (selfStack.stackSize <= 0 || blockPos.y() == world.getHeightBlocks() - 1 && this.block.getMaterial().isSolid()) {
             return false;
         }
 
         // Check if we're placing "inside" a slab
         if (id == this.block.id() && otherMeta == selfStack.getMetadata() && (side == Side.TOP || side == Side.BOTTOM)) {
             if ((side == Side.TOP && meta == 0) || (side == Side.BOTTOM && meta == 2)) {
-                AABB bbBox = AABB.fromPool(blockPos.x, blockPos.y, blockPos.z, blockPos.x + 1f, blockPos.y + 1f, blockPos.z + 1f);
-                if(!world.checkIfAABBIsClear(bbBox)) {
+                AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + 1f, blockPos.z() + 1f);
+                if (!world.checkIfAABBIsClear(bbBox)) {
                     return false;
                 }
 
                 world.setBlockDataNotify(blockPos, 1 | selfStack.getMetadata());
-                world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
                 selfStack.consumeItem(player);
                 return true;
             }
@@ -50,7 +51,7 @@ public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T> {
 
         // Offset position
         if (id != 0) {
-            blockPos = blockPos.add(side.getDirection());
+            blockPos = blockPos.add(side.getDirection(), new TilePos());
             id = world.getBlockId(blockPos);
             meta = world.getBlockData(blockPos) & 0b11;
             otherMeta = world.getBlockData(blockPos) & ~0b11;
@@ -59,28 +60,28 @@ public class ItemBlockSlab<T extends BlockLogic> extends ItemBlock<T> {
         // Check if the block we're placing into is a slab
         if (id == this.block.id() && otherMeta == selfStack.getMetadata()) {
             if ((yHit > 0.5f && meta == 0) || (yHit <= 0.5f && meta == 2) || (side == Side.BOTTOM && meta == 0) || (side == Side.TOP && meta == 2)) {
-                AABB bbBox = AABB.fromPool(blockPos.x, blockPos.y, blockPos.z, blockPos.x + 1f, blockPos.y + 1f, blockPos.z + 1f);
-                if(!world.checkIfAABBIsClear(bbBox)) {
+                AABBdc bbBox = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1f, blockPos.y() + 1f, blockPos.z() + 1f);
+                if (!world.checkIfAABBIsClear(bbBox)) {
                     return false;
                 }
 
                 world.setBlockDataNotify(blockPos, 1 | selfStack.getMetadata());
-                world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
                 selfStack.consumeItem(player);
                 return true;
             }
         }
 
         // Regular placement, as all else fails
-        if(world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) {
+        if (world.canBlockIdBePlacedAt(this.block.id(), blockPos, false, side)) {
             int placeMeta = getPlacedData(selfStack, world, player, blockPos, side, xHit, yHit);
-            if(world.setBlockIdDataNotify(blockPos, this.block.id(), placeMeta)) {
+            if (world.setBlockIdDataNotify(blockPos, this.block.id(), placeMeta)) {
                 if (player == null) {
                     this.block.onPlacedOnSide(world, blockPos, side, xHit, yHit);
                 } else {
                     this.block.onPlacedByMob(world, blockPos, side, player, xHit, yHit);
                 }
-                world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
+                world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
                 selfStack.consumeItem(player);
                 return true;
             }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockStairsPainted.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockStairsPainted.java
index b509dd2b0..129b7c0b0 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockStairsPainted.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlockStairsPainted.java
@@ -7,7 +7,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class ItemBlockStairsPainted<T extends BlockLogic> extends ItemBlock<T> {
@@ -18,7 +18,7 @@ public class ItemBlockStairsPainted<T extends BlockLogic> extends ItemBlock<T> {
     }
 
     @Override
-    public int getPlacedData(@NotNull ItemStack selfStack, @NotNull World world, Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public int getPlacedData(@NotNull ItemStack selfStack, @NotNull World world, Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
     	return selfStack.getMetadata();
     }
     
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
index 09d1c210d..e6d2444eb 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolHoe.java
@@ -14,6 +14,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -32,28 +33,28 @@ public class ItemToolHoe extends ItemTool {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         return till(selfStack, player, world, blockPos, side);
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        till(selfStack, null, world, blockPos.add(direction), direction.getSide());
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        till(selfStack, null, world, blockPos.add(direction, new TilePos()), direction.getSide());
     }
 
-    public boolean till(@NotNull ItemStack selfStack, @Nullable Player player, @NotNull World world, @NotNull TilePos blockPos, @NotNull Side side) {
+    public boolean till(@NotNull ItemStack selfStack, @Nullable Player player, @NotNull World world, @NotNull TilePosc blockPos, @NotNull Side side) {
         int id = world.getBlockId(blockPos);
-        int idAbove = world.getBlockId(blockPos.up());
-        if(side != Side.BOTTOM && idAbove == 0 && (id == Blocks.GRASS.id() || id == Blocks.DIRT.id() || id == Blocks.PATH_DIRT.id() || id == Blocks.GRASS_RETRO.id() || id == Blocks.MUD.id())) {
+        int idAbove = world.getBlockId(blockPos.up(new TilePos()));
+        if (side != Side.BOTTOM && idAbove == 0 && (id == Blocks.GRASS.id() || id == Blocks.DIRT.id() || id == Blocks.PATH_DIRT.id() || id == Blocks.GRASS_RETRO.id() || id == Blocks.MUD.id())) {
             int meta = 0;
-            if(id == Blocks.MUD.id()) {
+            if (id == Blocks.MUD.id()) {
                 meta = 1;
             }
-            world.playBlockSoundEffect(player, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, Blocks.DIRT, EnumBlockSoundEffectType.MINE);
-            if(!world.isClientSide) {
-                if(id == Blocks.GRASS.id() || id == Blocks.GRASS_RETRO.id() || id == Blocks.GRASS_SCORCHED.id()) {
-                    if(world.rand.nextInt(5) == 0) {
-                        world.dropItem(blockPos.up(), new ItemStack(Items.SEEDS_WHEAT));
+            world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.DIRT, EnumBlockSoundEffectType.MINE);
+            if (!world.isClientSide) {
+                if (id == Blocks.GRASS.id() || id == Blocks.GRASS_RETRO.id() || id == Blocks.GRASS_SCORCHED.id()) {
+                    if (world.rand.nextInt(5) == 0) {
+                        world.dropItem(blockPos.up(new TilePos()), new ItemStack(Items.SEEDS_WHEAT));
                     }
                 }
             }
@@ -68,13 +69,13 @@ public class ItemToolHoe extends ItemTool {
 
     @Override
     public boolean onBlockDestroyed(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Mob mob, @NotNull Block<?> removedBlock, @NotNull TilePos blockPos, @NotNull Side side) {
-        if(!world.isClientSide) {
-            if(removedBlock == Blocks.TALLGRASS || removedBlock == Blocks.TALLGRASS_FERN) {
-                if(this.material.isSilkTouch()) {
+        if (!world.isClientSide) {
+            if (removedBlock == Blocks.TALLGRASS || removedBlock == Blocks.TALLGRASS_FERN) {
+                if (this.material.isSilkTouch()) {
                     world.dropItem(blockPos, new ItemStack(removedBlock));
                     selfStack.damageItem(1, mob);
                 } else {
-                    if(world.rand.nextInt(4) == 0) {
+                    if (world.rand.nextInt(4) == 0) {
                         world.dropItem(blockPos, new ItemStack(Items.SEEDS_WHEAT));
                         selfStack.damageItem(1, mob);
                     }
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java
index df3adde04..2cac72861 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShears.java
@@ -11,11 +11,13 @@ import net.minecraft.core.item.material.ToolMaterial;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
 import java.util.Random;
@@ -26,9 +28,9 @@ public class ItemToolShears extends Item {
         setMaxStackSize(1);
         setMaxDamage(material.getDurability());
     }
-    
+
     public void onBlockSheared(@NotNull ItemStack selfStack, @Nullable Mob mob) {
-    	selfStack.damageItem(1, mob);
+        selfStack.damageItem(1, mob);
     }
 
     @Override
@@ -38,19 +40,19 @@ public class ItemToolShears extends Item {
 
     @Override
     public float getStrVsBlock(@NotNull ItemStack selfStack, @NotNull Block<?> block) {
-        if(block == Blocks.COBWEB || Block.hasLogicClass(block, BlockLogicLeavesBase.class)) {
+        if (block == Blocks.COBWEB || Block.hasLogicClass(block, BlockLogicLeavesBase.class)) {
             return 15F;
         }
-        if(block.hasTag(BlockTags.MINEABLE_BY_SHEARS)) {
+        if (block.hasTag(BlockTags.MINEABLE_BY_SHEARS)) {
             return 10f;
         }
         return super.getStrVsBlock(selfStack, block);
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        blockPos = blockPos.add(direction);
-        AABB box = AABB.fromPool(blockPos.x, blockPos.y, blockPos.z, blockPos.x + 1, blockPos.y + 1, blockPos.z + 1);
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        blockPos = blockPos.add(direction, new TilePos());
+        AABBdc box = new AABBd(blockPos.x(), blockPos.y(), blockPos.z(), blockPos.x() + 1, blockPos.y() + 1, blockPos.z() + 1);
         List<MobSheep> entities = world.getEntitiesWithinAABB(MobSheep.class, box);
         if (!entities.isEmpty()) {
             entities.get(0).onItemInteract(selfStack);
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
index cd0d1ab49..584313013 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolShovel.java
@@ -13,6 +13,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -29,20 +30,20 @@ public class ItemToolShovel extends ItemTool {
     }
 
     @Override
-    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePos blockPos, @NotNull Side side, double xHit, double yHit) {
+    public boolean onUseOnBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player player, @NotNull TilePosc blockPos, @NotNull Side side, double xHit, double yHit) {
         return shovelBlock(selfStack, world, player, blockPos, side);
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        shovelBlock(selfStack, world, null, blockPos.add(direction), direction.getSide());
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        shovelBlock(selfStack, world, null, blockPos.add(direction, new TilePos()), direction.getSide());
     }
 
-    public boolean shovelBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player entityplayer, @NotNull TilePos blockPos, @NotNull Side side) {
+    public boolean shovelBlock(@NotNull ItemStack selfStack, @NotNull World world, @Nullable Player entityplayer, @NotNull TilePosc blockPos, @NotNull Side side) {
         int blockId = world.getBlockId(blockPos);
-        int blockAbove = world.getBlockId(blockPos.up());
-        if(side != Side.BOTTOM && blockAbove == 0 && (blockId == Blocks.GRASS.id() || blockId == Blocks.DIRT.id() || blockId == Blocks.GRASS_RETRO.id() || blockId == Blocks.FARMLAND_DIRT.id())) {
-            world.playBlockSoundEffect(entityplayer, blockPos.x + 0.5F, blockPos.y + 0.5F, blockPos.z + 0.5F, Blocks.blocksList[blockId], EnumBlockSoundEffectType.PLACE);
+        int blockAbove = world.getBlockId(blockPos.up(new TilePos()));
+        if (side != Side.BOTTOM && blockAbove == 0 && (blockId == Blocks.GRASS.id() || blockId == Blocks.DIRT.id() || blockId == Blocks.GRASS_RETRO.id() || blockId == Blocks.FARMLAND_DIRT.id())) {
+            world.playBlockSoundEffect(entityplayer, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, Blocks.blocksList[blockId], EnumBlockSoundEffectType.PLACE);
             if (!world.isClientSide) {
                 world.setBlockIdNotify(blockPos, Blocks.PATH_DIRT.id());
                 selfStack.damageItem(1, entityplayer);
diff --git a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
index 2bfbe7bf8..b4c75d12c 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tool/ItemToolSword.java
@@ -13,6 +13,7 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
@@ -50,8 +51,8 @@ public class ItemToolSword extends Item
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePos blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        blockPos = blockPos.add(direction);
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        blockPos = blockPos.add(direction, new TilePos());
         Block<?> b = world.getBlock(blockPos);
         if (b == Blocks.PUMPKIN) {
             world.setBlockIdData(blockPos, Blocks.PUMPKIN_CARVED_IDLE.id(), direction.getOpposite().getId());
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/CommandSource.java b/game/core/src/main/java/net/minecraft/core/net/command/CommandSource.java
index b5ba0ba8f..1f720b5b7 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/CommandSource.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/CommandSource.java
@@ -3,9 +3,10 @@ package net.minecraft.core.net.command;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.util.phys.Vec3;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3dc;
 
 import java.util.Collection;
 import java.util.Collections;
@@ -31,9 +32,9 @@ public interface CommandSource {
 
     boolean hasAdmin();
 
-    @Nullable Vec3 getCoordinates(boolean offsetHeight);
+    @Nullable Vector3dc getCoordinates(boolean offsetHeight);
 
-    @Nullable Vec3 getBlockCoordinates();
+    @Nullable TilePosc getBlockCoordinates();
 
     boolean messageMayBeMultiline();
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeChunkCoordinates.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeChunkCoordinates.java
index 15284fa12..8c17b6df2 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeChunkCoordinates.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeChunkCoordinates.java
@@ -11,7 +11,7 @@ import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.net.command.helpers.Coordinates2D;
 import net.minecraft.core.net.command.helpers.IntegerCoordinate;
 import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.pos.TilePosc;
 
 import java.util.Arrays;
 import java.util.Collection;
@@ -49,13 +49,13 @@ public class ArgumentTypeChunkCoordinates implements ArgumentType<Coordinates2D>
     @Override
     public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
         String string = builder.getRemaining();
-        Vec3 coordinates = ((CommandSource)context.getSource()).getBlockCoordinates();
+        TilePosc coordinates = ((CommandSource) context.getSource()).getBlockCoordinates();
 
         if (coordinates == null) return builder.buildFuture();
 
         int[] roundedCoordinates = new int[]{
-                MathHelper.floor(coordinates.x / 16.0),
-                MathHelper.floor(coordinates.z / 16.0)
+            MathHelper.floor(coordinates.x() / 16.0),
+            MathHelper.floor(coordinates.z() / 16.0)
         };
 
         if (string.isEmpty()) {
@@ -65,7 +65,8 @@ public class ArgumentTypeChunkCoordinates implements ArgumentType<Coordinates2D>
                 builder.suggest(String.valueOf(roundedCoordinates[0]));
                 builder.suggest(roundedCoordinates[0] + " " + roundedCoordinates[1]);
                 builder.suggest(allCoordinates);
-            } catch (CommandSyntaxException ignored) {}
+            } catch (CommandSyntaxException ignored) {
+            }
         } else {
             String[] strings = string.split(" ");
             String allCoordinates;
@@ -75,7 +76,8 @@ public class ArgumentTypeChunkCoordinates implements ArgumentType<Coordinates2D>
                     this.parse(new StringReader(allCoordinates));
                     builder.suggest(strings[0] + " " + roundedCoordinates[1]);
                     builder.suggest(allCoordinates);
-                } catch (CommandSyntaxException ignored) {}
+                } catch (CommandSyntaxException ignored) {
+                }
             }
         }
         return builder.buildFuture();
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeIntegerCoordinates.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeIntegerCoordinates.java
index 98f268447..e278c2f9d 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeIntegerCoordinates.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeIntegerCoordinates.java
@@ -10,8 +10,7 @@ import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.net.command.helpers.IntegerCoordinate;
 import net.minecraft.core.net.command.helpers.IntegerCoordinates;
-import net.minecraft.core.util.helper.MathHelper;
-import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.pos.TilePosc;
 
 import java.util.Arrays;
 import java.util.Collection;
@@ -63,14 +62,14 @@ public class ArgumentTypeIntegerCoordinates implements ArgumentType<IntegerCoord
     @Override
     public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
         String string = builder.getRemaining();
-        Vec3 coordinates = ((CommandSource)context.getSource()).getBlockCoordinates();
+        TilePosc coordinates = ((CommandSource) context.getSource()).getBlockCoordinates();
 
         if (coordinates == null) return builder.buildFuture();
 
         int[] roundedCoordinates = new int[]{
-                MathHelper.floor(coordinates.x),
-                MathHelper.floor(coordinates.y),
-                MathHelper.floor(coordinates.z)
+            coordinates.x(),
+            coordinates.y(),
+            coordinates.z()
         };
 
         if (string.isEmpty()) {
@@ -80,7 +79,8 @@ public class ArgumentTypeIntegerCoordinates implements ArgumentType<IntegerCoord
                 builder.suggest(String.valueOf(roundedCoordinates[0]));
                 builder.suggest(roundedCoordinates[0] + " " + roundedCoordinates[1]);
                 builder.suggest(allCoordinates);
-            } catch (CommandSyntaxException ignored) {}
+            } catch (CommandSyntaxException ignored) {
+            }
         } else {
             String[] strings = string.split(" ");
             String allCoordinates;
@@ -91,14 +91,16 @@ public class ArgumentTypeIntegerCoordinates implements ArgumentType<IntegerCoord
                         this.parse(new StringReader(allCoordinates));
                         builder.suggest(strings[0] + " " + roundedCoordinates[1]);
                         builder.suggest(allCoordinates);
-                    } catch (CommandSyntaxException ignored) {}
+                    } catch (CommandSyntaxException ignored) {
+                    }
                     break;
                 case 2:
                     allCoordinates = strings[0] + " " + strings[1] + " " + roundedCoordinates[2];
                     try {
                         this.parse(new StringReader(allCoordinates));
                         builder.suggest(allCoordinates);
-                    } catch (CommandSyntaxException ignored) {}
+                    } catch (CommandSyntaxException ignored) {
+                    }
                     break;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeVec3.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeVector3d.java
similarity index 86%
rename from game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeVec3.java
rename to game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeVector3d.java
index 3baaf8c04..4e7f70156 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeVec3.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeVector3d.java
@@ -10,18 +10,18 @@ import net.minecraft.core.net.command.CommandSource;
 import net.minecraft.core.net.command.exceptions.CommandExceptions;
 import net.minecraft.core.net.command.helpers.DoubleCoordinate;
 import net.minecraft.core.net.command.helpers.DoubleCoordinates;
-import net.minecraft.core.util.phys.Vec3;
+import org.joml.Vector3dc;
 
 import java.util.Arrays;
 import java.util.Collection;
 import java.util.List;
 import java.util.concurrent.CompletableFuture;
 
-public class ArgumentTypeVec3 implements ArgumentType<DoubleCoordinates> {
+public class ArgumentTypeVector3d implements ArgumentType<DoubleCoordinates> {
     private static final List<String> EXAMPLES = Arrays.asList("~ ~ ~", "0 0 0", "~ ~60 ~", "~-20 ~10 ~-25.5");
 
-    public static ArgumentTypeVec3 vec3d() {
-        return new ArgumentTypeVec3();
+    public static ArgumentTypeVector3d vec3d() {
+        return new ArgumentTypeVector3d();
     }
 
     @Override
@@ -62,16 +62,16 @@ public class ArgumentTypeVec3 implements ArgumentType<DoubleCoordinates> {
     @Override
     public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
         String string = builder.getRemaining();
-        Vec3 coordinates = ((CommandSource) context.getSource()).getCoordinates(true);
+        Vector3dc coordinates = ((CommandSource) context.getSource()).getCoordinates(true);
 
         if (coordinates == null) return builder.buildFuture();
 
         if (string.isEmpty()) {
-            String allCoordinates = coordinates.x + " " + coordinates.y + " " + coordinates.z;
+            String allCoordinates = coordinates.x() + " " + coordinates.y() + " " + coordinates.z();
             try {
                 this.parse(new StringReader(allCoordinates));
-                builder.suggest(String.valueOf(coordinates.x));
-                builder.suggest(coordinates.x + " " + coordinates.y);
+                builder.suggest(String.valueOf(coordinates.x()));
+                builder.suggest(coordinates.x() + " " + coordinates.y());
                 builder.suggest(allCoordinates);
             } catch (CommandSyntaxException ignored) {
             }
@@ -80,16 +80,16 @@ public class ArgumentTypeVec3 implements ArgumentType<DoubleCoordinates> {
             String allCoordinates;
             switch (strings.length) {
                 case 1:
-                    allCoordinates = strings[0] + " " + coordinates.y + " " + coordinates.z;
+                    allCoordinates = strings[0] + " " + coordinates.y() + " " + coordinates.z();
                     try {
                         this.parse(new StringReader(allCoordinates));
-                        builder.suggest(strings[0] + " " + coordinates.y);
+                        builder.suggest(strings[0] + " " + coordinates.y());
                         builder.suggest(allCoordinates);
                     } catch (CommandSyntaxException ignored) {
                     }
                     break;
                 case 2:
-                    allCoordinates = strings[0] + " " + strings[1] + " " + coordinates.z;
+                    allCoordinates = strings[0] + " " + strings[1] + " " + coordinates.z();
                     try {
                         this.parse(new StringReader(allCoordinates));
                         builder.suggest(allCoordinates);
